/* $Id: parse.c 8 2023-02-21 16:57:28Z nishi $ */

#include <ncron/parse.h>

#include <ncron/util.h>
#include <ncron.h>

#include <stdlib.h>
#include <stdint.h>
#include <pwd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>

void process_entry(
			char** pstart,
			char** pend,
			char** pstep,
			int min, int max, char* str, int incr
){
	*pstart = malloc(1);
	*pstart[0] = -1;
	*pend = malloc(1);
	*pend[0] = -1;
	*pstep = malloc(1);
	*pstep[0] = -1;
	char* buffer = malloc(1);
	buffer[0] = 0;
	int i = 0;
	for(i = 0; i <= sstrlen(str); i++){
		char ch = str[i];
		if(ch == ',' || ch == 0){
			int64_t c;
			char* range = buffer;
			char* step = NULL;
			if((c = sindexof(buffer, "/")) != -1){
				buffer[c] = 0;
				step = buffer + c + 1;
			}
			char start = -2;
			char end = -2;
			if((c = sindexof(range, "-")) != -1){
				range[c] = 0;
				char* strstart = range;
				char* strend = range + c + 1;
				start = atoi(strstart) + incr;
				end = atoi(strend) + incr;
			}else{
				if(strcmp(range, "*") == 0){
					start = min;
					end = max;
				}else{
					start = atoi(range) + incr;
				}
			}
			*pstart = scappend(*pstart, start);
			*pend = scappend(*pend, end);
			if(step == NULL){
				*pstep = scappend(*pstep, 1);
			}else{
				*pstep = scappend(*pstep, atoi(step));
			}
			free(buffer);
			buffer = malloc(1);
			buffer[0] = 0;
			if(ch == 0) break;
		}else{
			char* tmp = buffer;
			char* tmp2 = malloc(2);
			tmp2[0] = ch;
			tmp2[1] = 0;
			buffer = sstrcat(tmp, tmp2);
			free(tmp);
			free(tmp2);
		}
	}
	free(buffer);
}

struct ncrontab* ncron_parse_file(const char* path, struct ncrontab* result, uid_t defuid, gid_t defgid, char allowchange){
	int i = 0;
	char* buffer = malloc(1);
	buffer[0] = 0;
	int counter = 0;
	FILE* f = fopen(path, "r");
	if(f != NULL){
		char ch;
		char* shell = sstrdup("/bin/sh");
		char* path = sstrdup("/bin:/sbin:/usr/bin:/usr/sbin");
		while(1){
			fread(&ch, 1, 1, f);
			if(feof(f) || ch == '\n'){
				if(counter != 0){
					if(buffer[0] != '#'){
						if(sstartswith(buffer, "SHELL=")){
							free(shell);
							shell = sstrdup(buffer + sstrlen("SHELL="));
						}else if(sstartswith(buffer, "PATH=")){
							free(path);
							path = sstrdup(buffer + sstrlen("PATH="));
						}else if(sstartswith(buffer, "MAILTO=")){
						}else{
							struct ncron_entry* entry = malloc(sizeof(*entry));
							entry->e_shell = sstrdup(shell);
							entry->e_path = sstrdup(path);
							entry->e_minute_start = NULL;
							entry->e_hour_start = NULL;
							entry->e_date_start = NULL;
							entry->e_month_start = NULL;
							entry->e_day_start = NULL;

							entry->e_minute_end = NULL;
							entry->e_hour_end = NULL;
							entry->e_date_end = NULL;
							entry->e_month_end = NULL;
							entry->e_day_end = NULL;

							entry->e_minute_step = NULL;
							entry->e_hour_step = NULL;
							entry->e_date_step = NULL;
							entry->e_month_step = NULL;
							entry->e_day_step = NULL;

							entry->e_reboot = 0;
							entry->e_uid = defuid;
							entry->e_gid = defgid;

							int64_t minute_index = sindexof(buffer, "\t ");
							char* minute = mqueue(malloc(minute_index + 1));
							minute[minute_index] = 0;
							smemcpy(minute, buffer, minute_index);
							if(buffer[0] == '@'){
								if(strcmp(minute, "@yearly") == 0){
									entry->e_minute_start = scarray(0);
									entry->e_minute_end = scarray(-2);

									entry->e_hour_start = scarray(0);
									entry->e_hour_end = scarray(-2);

									entry->e_date_start = scarray(1);
									entry->e_date_end = scarray(-2);

									entry->e_month_start = scarray(0);
									entry->e_month_end = scarray(-2);

									entry->e_day_start = scarray(0);
									entry->e_day_end = scarray(6);
								}else if(strcmp(minute, "@monthly") == 0){
									entry->e_minute_start = scarray(0);
									entry->e_minute_end = scarray(-2);

									entry->e_hour_start = scarray(0);
									entry->e_hour_end = scarray(-2);

									entry->e_date_start = scarray(1);
									entry->e_date_end = scarray(-2);

									entry->e_month_start = scarray(0);
									entry->e_month_end = scarray(11);

									entry->e_day_start = scarray(0);
									entry->e_day_end = scarray(6);
								}else if(strcmp(minute, "@weekly") == 0){
									entry->e_minute_start = scarray(0);
									entry->e_minute_end = scarray(-2);

									entry->e_hour_start = scarray(0);
									entry->e_hour_end = scarray(-2);

									entry->e_date_start = scarray(1);
									entry->e_date_end = scarray(31);

									entry->e_month_start = scarray(0);
									entry->e_month_end = scarray(11);

									entry->e_day_start = scarray(0);
									entry->e_day_end = scarray(-2);
								}else if(strcmp(minute, "@daily") == 0){
									entry->e_minute_start = scarray(0);
									entry->e_minute_end = scarray(-2);

									entry->e_hour_start = scarray(0);
									entry->e_hour_end = scarray(-2);

									entry->e_date_start = scarray(1);
									entry->e_date_end = scarray(31);

									entry->e_month_start = scarray(0);
									entry->e_month_end = scarray(11);

									entry->e_day_start = scarray(0);
									entry->e_day_end = scarray(6);
								}else if(strcmp(minute, "@hourly") == 0){
									entry->e_minute_start = scarray(0);
									entry->e_minute_end = scarray(-2);

									entry->e_hour_start = scarray(0);
									entry->e_hour_end = scarray(23);

									entry->e_date_start = scarray(1);
									entry->e_date_end = scarray(31);

									entry->e_month_start = scarray(0);
									entry->e_month_end = scarray(11);

									entry->e_day_start = scarray(0);
									entry->e_day_end = scarray(6);
								}else if(strcmp(minute, "@reboot") == 0){
									entry->e_reboot = 1;
								}else{
									free(entry);
									mqueue_free();
									goto skip;
								}
								int64_t user_index = sindexof(buffer + minute_index + scontinue(buffer + minute_index, "\t "), "\t ");
								char* user = mqueue(malloc(user_index + 1));
								user[user_index] = 0;
								smemcpy(user, minute_index + buffer + scontinue(buffer + minute_index, "\t "), user_index);
								if(allowchange == 1){
									struct passwd* pwd = getpwnam(user);
									if(pwd != NULL){
										entry->e_uid = pwd->pw_uid;
										entry->e_gid = pwd->pw_gid;
									}
								}
								entry->e_command = sstrdup(user_index + scontinue(buffer + minute_index, "\t ") + minute_index + buffer + 1);
							}else{
								int spaces = scontinue(buffer + minute_index, "\t ");
								int64_t hour_index = sindexof(buffer + minute_index + spaces, "\t ");
								char* hour = mqueue(malloc(hour_index + 1));
								hour[hour_index] = 0;
								smemcpy(hour, minute_index + buffer + spaces, hour_index);
	
								spaces += scontinue(buffer + minute_index + spaces + hour_index, "\t ");
								int64_t date_index = sindexof(buffer + spaces + hour_index + minute_index, "\t ");
								char* date = mqueue(malloc(date_index + 1));
								date[date_index] = 0;
								smemcpy(date, spaces + hour_index + minute_index + buffer, date_index);

								spaces += scontinue(buffer + spaces + minute_index + hour_index + date_index, "\t ");
								int64_t month_index = sindexof(buffer + spaces + date_index + hour_index + minute_index, "\t ");
								char* month = mqueue(malloc(month_index + 1));
								month[month_index] = 0;
								smemcpy(month, spaces + date_index + hour_index + minute_index + buffer, month_index);

								spaces += scontinue(buffer + spaces + minute_index + hour_index + date_index + month_index, "\t ");
								int64_t day_index = sindexof(buffer + spaces + month_index + date_index + hour_index + minute_index, "\t ");
								char* day = mqueue(malloc(day_index + 1));
								day[day_index] = 0;
								smemcpy(day, spaces + month_index + date_index + hour_index + minute_index + buffer, day_index);

								spaces += scontinue(buffer + spaces + minute_index + hour_index + date_index + day_index + month_index, "\t ");
								int64_t user_index = sindexof(buffer + spaces + day_index + month_index + date_index + hour_index + minute_index, "\t ");
								char* user = mqueue(malloc(user_index + 1));
								user[user_index] = 0;
								smemcpy(user, day_index + spaces + month_index + date_index + hour_index + minute_index + buffer, user_index);

								process_entry(
										&entry->e_minute_start,
										&entry->e_minute_end,
										&entry->e_minute_step,
										0, 59, minute, 0
								);
								process_entry(
										&entry->e_hour_start,
										&entry->e_hour_end,
										&entry->e_hour_step,
										0, 23, hour, 0
								);
								process_entry(
										&entry->e_date_start,
										&entry->e_date_end,
										&entry->e_date_step,
										1, 31, date, 0
								);
								process_entry(
										&entry->e_month_start,
										&entry->e_month_end,
										&entry->e_month_step,
										0, 11, month, -1
								);
								process_entry(
										&entry->e_day_start,
										&entry->e_day_end,
										&entry->e_day_step,
										1, 31, day, 0
								);

								spaces += scontinue(buffer + spaces + minute_index + hour_index + date_index + day_index + month_index + user_index, "\t ");
								entry->e_command = sstrdup(user_index + day_index + month_index + date_index + hour_index + minute_index + buffer + spaces);
								if(allowchange == 1){
									struct passwd* pwd = getpwnam(user);
									if(pwd != NULL){
										entry->e_uid = pwd->pw_uid;
										entry->e_gid = pwd->pw_gid;
									}
								}
							}
							mqueue_free();

							result->tabs = realloc(result->tabs, sizeof(*result->tabs) * (result->tab_counter + 2));
							result->tabs[result->tab_counter] = entry;
							result->tabs[result->tab_counter + 1] = NULL;
							result->tab_counter++;
						}
					}
				}
skip:
				free(buffer);
				buffer = malloc(1);
				buffer[0] = 0;
				counter = 0;
				if(feof(f)) break;
			}else{
				buffer = realloc(buffer, counter + 2);
				buffer[counter] = ch;
				buffer[counter + 1] = 0;
				counter++;
			}
		}
		fclose(f);
	}
	return result;
}

struct ncrontab* ncron_parse(){
	struct ncrontab* result = malloc(sizeof(*result));
	result->tabs = malloc(sizeof(*result->tabs));
	result->tabs[0] = NULL;
	result->tab_counter = 0;
	result = ncron_parse_file("/etc/crontab", result, 0, 0, 1);
	DIR* dir = opendir("/etc/cron.d");
	struct dirent* d;
	if(dir != NULL){
		while((d = readdir(dir)) != NULL){
			char* path = sstrcat("/etc/cron.d/", d->d_name);
			result = ncron_parse_file(path, result, 0, 0, 1);
			free(path);
		}
		closedir(dir);
	}
	return result;
}

void ncron_ncrontab_free(struct ncrontab* tab){
	int i;
	for(i = 0; tab->tabs[i] != NULL; i++){
		struct ncron_entry* entry = tab->tabs[i];
		if(entry->e_minute_start != NULL) free(entry->e_minute_start);
		if(entry->e_hour_start != NULL) free(entry->e_hour_start);
		if(entry->e_date_start != NULL) free(entry->e_date_start);
		if(entry->e_month_start != NULL) free(entry->e_month_start);
		if(entry->e_day_start != NULL) free(entry->e_day_start);

		if(entry->e_minute_end != NULL) free(entry->e_minute_end);
		if(entry->e_hour_end != NULL) free(entry->e_hour_end);
		if(entry->e_date_end != NULL) free(entry->e_date_end);
		if(entry->e_month_end != NULL) free(entry->e_month_end);
		if(entry->e_day_end != NULL) free(entry->e_day_end);

		if(entry->e_minute_step != NULL) free(entry->e_minute_step);
		if(entry->e_hour_step != NULL) free(entry->e_hour_step);
		if(entry->e_date_step != NULL) free(entry->e_date_step);
		if(entry->e_month_step != NULL) free(entry->e_month_step);
		if(entry->e_day_step != NULL) free(entry->e_day_step);

		free(entry->e_shell);
		free(entry->e_path);
		free(entry->e_command);
		free(entry);
	}
	free(tab->tabs);
	free(tab);
}
