/* $Id: util.c 6 2023-02-20 17:11:41Z nishi $ */

#include <ncron/util.h>

#include <stdlib.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>

size_t sstrlen(const char* str){
	size_t result;
	for(result = 0; str[result] != 0; result++);
	return result;
}

char* sstrcpy(char* dest, const char* src){
	size_t i;
	for(i = 0; src[i] != 0; dest[i] = src[i], i++);
	dest[i] = 0;
}

char* sstrcat(const char* str1, const char* str2){
	char* result = malloc(sstrlen(str1) + sstrlen(str2) + 1);
	result[sstrlen(str1) + sstrlen(str2)] = 0;
	sstrcpy(result, str1);
	sstrcpy(result + sstrlen(str1), str2);
	return result;
}

char* sstrcat3(const char* str1, const char* str2, const char* str3){
	char* tmp = sstrcat(str1, str2);
	char* result = sstrcat(tmp, str3);
	free(tmp);
	return result;
}

int64_t sindexof(const char* target, const char* match){
	int i, j;
	for(i = 0; target[i] != 0; i++){
		for(j = 0; match[j] != 0; j++){
			if(target[i] == match[j]) return i;
		}
	}
	return -1;
}

int64_t scontinue(const char* target, const char* match){
	int i, j;
	int64_t incr = 0;
	for(i = 0; target[i] != 0; i++){
		char matched = 0;
		for(j = 0; match[j] != 0; j++){
			if(target[i] == match[j]){
				matched = 1;
				incr++;
				break;
			}
		}
		if(matched == 0) return incr;
	}
	return -1;
}

char* sstrdup(const char* str){
	char* result = malloc(sstrlen(str) + 1);
	result[sstrlen(str)] = 0;
	sstrcpy(result, str);
	return result;
}

char* scarray(char ch){
	char* result = malloc(2);
	result[1] = -1;
	result[0] = ch;
	return result;
}

char* scappend(char* array, char ch){
	int i;
	for(i = 0; array[i] != -1; i++);
	array = realloc(array, i + 2);
	array[i] = ch;
	array[i + 1] = -1;
	return array;
}

void smemcpy(void* dest_, void* src_, size_t size){
	char* dest = dest_;
	char* src = src_;
	int i;
	for(i = 0; i < size; i++) dest[i] = src[i];
}

void** mqueue_ = NULL;
size_t mqueue_len = 0;

void* mqueue(void* ptr){
	if(mqueue_ == NULL){
		mqueue_ = malloc(0);
	}
	mqueue_ = realloc(mqueue_, sizeof(*mqueue_) * (mqueue_len + 1));
	mqueue_[mqueue_len] = ptr;
	mqueue_len++;
	return ptr;
}

void mqueue_free(){
	if(mqueue_ == NULL) return;
	size_t i;
	for(i = 0; i < mqueue_len; i++) free(mqueue_[i]);
	free(mqueue_);
	mqueue_len = 0;
	mqueue_ = malloc(0);
}

bool sstartswith(const char* target, const char* starts_with){
	if(sstrlen(starts_with) > sstrlen(target)) return false;
	int i;
	for(i = 0; starts_with[i] != 0; i++){
		if(starts_with[i] != target[i]) return false;
	}
	return true;
}
